Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkThinPlateSplineTransform Class Reference

`#include <vtkThinPlateSplineTransform.h>`

Inheritance diagram for vtkThinPlateSplineTransform:

[legend]
Collaboration diagram for vtkThinPlateSplineTransform:

[legend]
List of all members.

## Detailed Description

a nonlinear warp transformation

Date:
  2002/01/22 15:30:39

Revision:
  1.22

vtkThinPlateSplineTransform describes a nonlinear warp transform defined by a set of source and target landmarks. Any point on the mesh close to a source landmark will be moved to a place close to the corresponding target landmark. The points in between are interpolated smoothly using Bookstein's Thin Plate Spline algorithm.

Warning:
  1) The inverse transform is calculated using an iterative method, and is several times more expensive than the forward transform. 2) Whenever you add, subtract, or set points you must call Modified() on the vtkPoints object, or the transformation might not update. 3) Collinear point configurations (except those that lie in the XY plane) result in an unstable transformation.

See also:
  vtkGridTransform vtkGeneralTransform

Created by:
  - Gobbi, David

CVS contributions (if > 5%):
  - Gobbi, David (93%)

CVS logs (CVSweb):
  - .`cxx` (`/Hybrid/vtkThinPlateSplineTransform.cxx)`
  - .`h` (`/Hybrid/vtkThinPlateSplineTransform.h)`

Tests:
  vtkThinPlateSplineTransform (Tests)

Definition at line 60 of file vtkThinPlateSplineTransform.h.

## Public Types
typedef vtkWarpTransform | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
unsigned long | GetMTime ()
vtkAbstractTransform * | MakeTransform ()
virtual double | GetSigma ()
virtual void | SetSigma (double)
void | SetBasis (int basis)
virtual int | GetBasis ()
void | SetBasisToR ()
void | SetBasisToR2LogR ()
const char * | GetBasisAsString ()
void | SetBasisFunction (double(*U)(double r))
void | SetBasisDerivative (double(*dUdr)(double r, double &dU))
void | SetSourceLandmarks (vtkPoints *source)
virtual vtkPoints * | GetSourceLandmarks ()
void | SetTargetLandmarks (vtkPoints *target)
virtual vtkPoints * | GetTargetLandmarks ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkThinPlateSplineTransform * | SafeDownCast (vtkObject *o)
vtkThinPlateSplineTransform * | New ()
## Protected Methods
| vtkThinPlateSplineTransform ()
| ~vtkThinPlateSplineTransform ()
void | InternalUpdate ()
void | InternalDeepCopy (vtkAbstractTransform *transform)
void | ForwardTransformPoint (const float in[3], float out[3])
void | ForwardTransformPoint (const double in[3], double out[3])
void | ForwardTransformDerivative (const float in[3], float out[3], float derivative[3][3])
void | ForwardTransformDerivative (const double in[3], double out[3], double derivative[3][3])
## Protected Attributes
double | Sigma
vtkPoints * | SourceLandmarks
vtkPoints * | TargetLandmarks
double(* | BasisFunction )(double r)
double(* | BasisDerivative )(double r, double &dUdr)
int | Basis
int | NumberOfPoints
double ** | MatrixW

## Member Typedef Documentation

typedef vtkWarpTransform vtkThinPlateSplineTransform::Superclass

| Reimplemented from vtkWarpTransform. Definition at line 63 of file vtkThinPlateSplineTransform.h.

## Constructor & Destructor Documentation

vtkThinPlateSplineTransform::vtkThinPlateSplineTransform | ( |  | ) | `[protected]`

vtkThinPlateSplineTransform::~vtkThinPlateSplineTransform | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkThinPlateSplineTransform::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkWarpTransform.

int vtkThinPlateSplineTransform::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkWarpTransform.

virtual int vtkThinPlateSplineTransform::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkWarpTransform.

vtkThinPlateSplineTransform* vtkThinPlateSplineTransform::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkWarpTransform.

void vtkThinPlateSplineTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkWarpTransform.

vtkThinPlateSplineTransform* vtkThinPlateSplineTransform::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual double vtkThinPlateSplineTransform::GetSigma | ( |  | ) | `[virtual]`

| Specify the 'stiffness' of the spline. The default is 1.0.

virtual void vtkThinPlateSplineTransform::SetSigma | ( | double |  | ) | `[virtual]`

| Specify the 'stiffness' of the spline. The default is 1.0.

void vtkThinPlateSplineTransform::SetBasis | ( | int | basis | ) |

| Specify the radial basis function to use. The default is R2LogR which is what most people use as the thin plate spline.

virtual int vtkThinPlateSplineTransform::GetBasis | ( |  | ) | `[virtual]`

| Specify the radial basis function to use. The default is R2LogR which is what most people use as the thin plate spline.

void vtkThinPlateSplineTransform::SetBasisToR | ( |  | ) | `[inline]`

| Specify the radial basis function to use. The default is R2LogR which is what most people use as the thin plate spline. Definition at line 78 of file vtkThinPlateSplineTransform.h. References VTK_RBF_R.

void vtkThinPlateSplineTransform::SetBasisToR2LogR | ( |  | ) | `[inline]`

| Specify the radial basis function to use. The default is R2LogR which is what most people use as the thin plate spline. Definition at line 79 of file vtkThinPlateSplineTransform.h. References VTK_RBF_R2LOGR.

const char* vtkThinPlateSplineTransform::GetBasisAsString | ( |  | ) |

| Specify the radial basis function to use. The default is R2LogR which is what most people use as the thin plate spline.

void vtkThinPlateSplineTransform::SetBasisFunction | ( | double(* | U)(double r) | ) | `[inline]`

| Set the radial basis function to a custom function. You must supply both the function and its derivative with respect to r. Definition at line 87 of file vtkThinPlateSplineTransform.h. References vtkObject::Modified(), and VTK_RBF_CUSTOM.

void vtkThinPlateSplineTransform::SetBasisDerivative | ( | double(* | dUdr)(double r, double &dU) | ) | `[inline]`

| Set the radial basis function to a custom function. You must supply both the function and its derivative with respect to r. Definition at line 92 of file vtkThinPlateSplineTransform.h. References vtkObject::Modified().

void vtkThinPlateSplineTransform::SetSourceLandmarks | ( | vtkPoints * | source | ) |

| Set the source landmarks for the warp. If you add or change the vtkPoints object, you must call Modified() on it or the transformation might not update.

virtual vtkPoints* vtkThinPlateSplineTransform::GetSourceLandmarks | ( |  | ) | `[virtual]`

| Set the source landmarks for the warp. If you add or change the vtkPoints object, you must call Modified() on it or the transformation might not update.

void vtkThinPlateSplineTransform::SetTargetLandmarks | ( | vtkPoints * | target | ) |

| Set the target landmarks for the warp. If you add or change the vtkPoints object, you must call Modified() on it or the transformation might not update.

virtual vtkPoints* vtkThinPlateSplineTransform::GetTargetLandmarks | ( |  | ) | `[virtual]`

| Set the target landmarks for the warp. If you add or change the vtkPoints object, you must call Modified() on it or the transformation might not update.

unsigned long vtkThinPlateSplineTransform::GetMTime | ( |  | ) | `[virtual]`

| Get the MTime. Reimplemented from vtkAbstractTransform.

vtkAbstractTransform* vtkThinPlateSplineTransform::MakeTransform | ( |  | ) | `[virtual]`

| Make another transform of the same type. Implements vtkAbstractTransform.

void vtkThinPlateSplineTransform::InternalUpdate | ( |  | ) | `[protected, virtual]`

| Prepare the transformation for application. Reimplemented from vtkAbstractTransform.

void vtkThinPlateSplineTransform::InternalDeepCopy | ( | vtkAbstractTransform * | transform | ) | `[protected, virtual]`

| This method does no type checking, use DeepCopy instead. Reimplemented from vtkAbstractTransform.

void vtkThinPlateSplineTransform::ForwardTransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) | `[protected, virtual]`

| If the InverseFlag is set to 0, then a call to InternalTransformPoint results in a call to ForwardTransformPoint. Implements vtkWarpTransform.

void vtkThinPlateSplineTransform::ForwardTransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) | `[protected, virtual]`

| If the InverseFlag is set to 0, then a call to InternalTransformPoint results in a call to ForwardTransformPoint. Implements vtkWarpTransform.

void vtkThinPlateSplineTransform::ForwardTransformDerivative | ( | const float | in[3],
|  | float | out[3],
|  | float | derivative[3][3]
| ) | `[protected, virtual]`

| Calculate the forward transform as well as the derivative. Implements vtkWarpTransform.

void vtkThinPlateSplineTransform::ForwardTransformDerivative | ( | const double | in[3],
|  | double | out[3],
|  | double | derivative[3][3]
| ) | `[protected, virtual]`

| Calculate the forward transform as well as the derivative. Implements vtkWarpTransform.

## Member Data Documentation

double vtkThinPlateSplineTransform::Sigma`[protected]`

| Definition at line 138 of file vtkThinPlateSplineTransform.h.

vtkPoints* vtkThinPlateSplineTransform::SourceLandmarks`[protected]`

| Definition at line 139 of file vtkThinPlateSplineTransform.h.

vtkPoints* vtkThinPlateSplineTransform::TargetLandmarks`[protected]`

| Definition at line 140 of file vtkThinPlateSplineTransform.h.

double(* vtkThinPlateSplineTransform::BasisFunction)(double r)`[protected]`

double(* vtkThinPlateSplineTransform::BasisDerivative)(double r, double& dUdr)`[protected]`

int vtkThinPlateSplineTransform::Basis`[protected]`

| Definition at line 147 of file vtkThinPlateSplineTransform.h.

int vtkThinPlateSplineTransform::NumberOfPoints`[protected]`

| Definition at line 149 of file vtkThinPlateSplineTransform.h.

double** vtkThinPlateSplineTransform::MatrixW`[protected]`

| Definition at line 150 of file vtkThinPlateSplineTransform.h.

The documentation for this class was generated from the following file:

- Hybrid/vtkThinPlateSplineTransform.h